<?php


abstract class BaseTblbloguserPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'tblbloguser';

	
	const CLASS_DEFAULT = 'lib.model.Tblbloguser';

	
	const NUM_COLUMNS = 11;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;

	
	const US_BLOG = 'tblbloguser.US_BLOG';

	
	const US_USER = 'tblbloguser.US_USER';

	
	const US_ROLE = 'tblbloguser.US_ROLE';

	
	const US_CATEGORIES = 'tblbloguser.US_CATEGORIES';

	
	const US_PICTURE = 'tblbloguser.US_PICTURE';

	
	const US_LASTVISIT = 'tblbloguser.US_LASTVISIT';

	
	const US_JOINDATE = 'tblbloguser.US_JOINDATE';

	
	const US_FULLNAME = 'tblbloguser.US_FULLNAME';

	
	const US_NICKNAME = 'tblbloguser.US_NICKNAME';

	
	const US_EMAIL = 'tblbloguser.US_EMAIL';

	
	const US_MANAGECAT = 'tblbloguser.US_MANAGECAT';

	
	public static $instances = array();

	
	private static $mapBuilder = null;

	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('UsBlog', 'UsUser', 'UsRole', 'UsCategories', 'UsPicture', 'UsLastvisit', 'UsJoindate', 'UsFullname', 'UsNickname', 'UsEmail', 'UsManagecat', ),
		BasePeer::TYPE_STUDLYPHPNAME => array ('usBlog', 'usUser', 'usRole', 'usCategories', 'usPicture', 'usLastvisit', 'usJoindate', 'usFullname', 'usNickname', 'usEmail', 'usManagecat', ),
		BasePeer::TYPE_COLNAME => array (self::US_BLOG, self::US_USER, self::US_ROLE, self::US_CATEGORIES, self::US_PICTURE, self::US_LASTVISIT, self::US_JOINDATE, self::US_FULLNAME, self::US_NICKNAME, self::US_EMAIL, self::US_MANAGECAT, ),
		BasePeer::TYPE_FIELDNAME => array ('us_blog', 'us_user', 'us_role', 'us_categories', 'us_picture', 'us_lastvisit', 'us_joindate', 'us_fullname', 'us_nickname', 'us_email', 'us_managecat', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('UsBlog' => 0, 'UsUser' => 1, 'UsRole' => 2, 'UsCategories' => 3, 'UsPicture' => 4, 'UsLastvisit' => 5, 'UsJoindate' => 6, 'UsFullname' => 7, 'UsNickname' => 8, 'UsEmail' => 9, 'UsManagecat' => 10, ),
		BasePeer::TYPE_STUDLYPHPNAME => array ('usBlog' => 0, 'usUser' => 1, 'usRole' => 2, 'usCategories' => 3, 'usPicture' => 4, 'usLastvisit' => 5, 'usJoindate' => 6, 'usFullname' => 7, 'usNickname' => 8, 'usEmail' => 9, 'usManagecat' => 10, ),
		BasePeer::TYPE_COLNAME => array (self::US_BLOG => 0, self::US_USER => 1, self::US_ROLE => 2, self::US_CATEGORIES => 3, self::US_PICTURE => 4, self::US_LASTVISIT => 5, self::US_JOINDATE => 6, self::US_FULLNAME => 7, self::US_NICKNAME => 8, self::US_EMAIL => 9, self::US_MANAGECAT => 10, ),
		BasePeer::TYPE_FIELDNAME => array ('us_blog' => 0, 'us_user' => 1, 'us_role' => 2, 'us_categories' => 3, 'us_picture' => 4, 'us_lastvisit' => 5, 'us_joindate' => 6, 'us_fullname' => 7, 'us_nickname' => 8, 'us_email' => 9, 'us_managecat' => 10, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, )
	);

	
	public static function getMapBuilder()
	{
		if (self::$mapBuilder === null) {
			self::$mapBuilder = new TblbloguserMapBuilder();
		}
		return self::$mapBuilder;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(TblbloguserPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(TblbloguserPeer::US_BLOG);

		$criteria->addSelectColumn(TblbloguserPeer::US_USER);

		$criteria->addSelectColumn(TblbloguserPeer::US_ROLE);

		$criteria->addSelectColumn(TblbloguserPeer::US_CATEGORIES);

		$criteria->addSelectColumn(TblbloguserPeer::US_PICTURE);

		$criteria->addSelectColumn(TblbloguserPeer::US_LASTVISIT);

		$criteria->addSelectColumn(TblbloguserPeer::US_JOINDATE);

		$criteria->addSelectColumn(TblbloguserPeer::US_FULLNAME);

		$criteria->addSelectColumn(TblbloguserPeer::US_NICKNAME);

		$criteria->addSelectColumn(TblbloguserPeer::US_EMAIL);

		$criteria->addSelectColumn(TblbloguserPeer::US_MANAGECAT);

	}

	
	public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
	{
				$criteria = clone $criteria;

								$criteria->setPrimaryTableName(TblbloguserPeer::TABLE_NAME);

		if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->setDistinct();
		}

		if (!$criteria->hasSelectClause()) {
			TblbloguserPeer::addSelectColumns($criteria);
		}

		$criteria->clearOrderByColumns(); 		$criteria->setDbName(self::DATABASE_NAME); 
		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
				$stmt = BasePeer::doCount($criteria, $con);

		if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$count = (int) $row[0];
		} else {
			$count = 0; 		}
		$stmt->closeCursor();
		return $count;
	}
	
	public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = TblbloguserPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, PropelPDO $con = null)
	{
		return TblbloguserPeer::populateObjects(TblbloguserPeer::doSelectStmt($criteria, $con));
	}
	
	public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		if (!$criteria->hasSelectClause()) {
			$criteria = clone $criteria;
			TblbloguserPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

				return BasePeer::doSelect($criteria, $con);
	}
	
	public static function addInstanceToPool(Tblbloguser $obj, $key = null)
	{
		if (Propel::isInstancePoolingEnabled()) {
			if ($key === null) {
				$key = serialize(array((string) $obj->getUsBlog(), (string) $obj->getUsUser()));
			} 			self::$instances[$key] = $obj;
		}
	}

	
	public static function removeInstanceFromPool($value)
	{
		if (Propel::isInstancePoolingEnabled() && $value !== null) {
			if (is_object($value) && $value instanceof Tblbloguser) {
				$key = serialize(array((string) $value->getUsBlog(), (string) $value->getUsUser()));
			} elseif (is_array($value) && count($value) === 2) {
								$key = serialize(array((string) $value[0], (string) $value[1]));
			} else {
				$e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or Tblbloguser object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
				throw $e;
			}

			unset(self::$instances[$key]);
		}
	} 
	
	public static function getInstanceFromPool($key)
	{
		if (Propel::isInstancePoolingEnabled()) {
			if (isset(self::$instances[$key])) {
				return self::$instances[$key];
			}
		}
		return null; 	}
	
	
	public static function clearInstancePool()
	{
		self::$instances = array();
	}
	
	
	public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
	{
				if ($row[$startcol + 0] === null && $row[$startcol + 1] === null) {
			return null;
		}
		return serialize(array((string) $row[$startcol + 0], (string) $row[$startcol + 1]));
	}

	
	public static function populateObjects(PDOStatement $stmt)
	{
		$results = array();
	
				$cls = TblbloguserPeer::getOMClass();
		$cls = substr('.'.$cls, strrpos('.'.$cls, '.') + 1);
				while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$key = TblbloguserPeer::getPrimaryKeyHashFromRow($row, 0);
			if (null !== ($obj = TblbloguserPeer::getInstanceFromPool($key))) {
																$results[] = $obj;
			} else {
		
				$obj = new $cls();
				$obj->hydrate($row);
				$results[] = $obj;
				TblbloguserPeer::addInstanceToPool($obj, $key);
			} 		}
		$stmt->closeCursor();
		return $results;
	}

	
	public static function doCountJoinTbluser(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
				$criteria = clone $criteria;

								$criteria->setPrimaryTableName(TblbloguserPeer::TABLE_NAME);

		if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->setDistinct();
		}

		if (!$criteria->hasSelectClause()) {
			TblbloguserPeer::addSelectColumns($criteria);
		}
		
		$criteria->clearOrderByColumns(); 		
				$criteria->setDbName(self::DATABASE_NAME);

		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		$criteria->addJoin(array(TblbloguserPeer::US_USER,), array(TbluserPeer::US_ID,), $join_behavior);
		$stmt = BasePeer::doCount($criteria, $con);

		if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$count = (int) $row[0];
		} else {
			$count = 0; 		}
		$stmt->closeCursor();
		return $count;
	}


	
	public static function doSelectJoinTbluser(Criteria $c, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TblbloguserPeer::addSelectColumns($c);
		$startcol = (TblbloguserPeer::NUM_COLUMNS - TblbloguserPeer::NUM_LAZY_LOAD_COLUMNS);
		TbluserPeer::addSelectColumns($c);

		$c->addJoin(array(TblbloguserPeer::US_USER,), array(TbluserPeer::US_ID,), $join_behavior);
		$stmt = BasePeer::doSelect($c, $con);
		$results = array();

		while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$key1 = TblbloguserPeer::getPrimaryKeyHashFromRow($row, 0);
			if (null !== ($obj1 = TblbloguserPeer::getInstanceFromPool($key1))) {
															} else {

				$omClass = TblbloguserPeer::getOMClass();

				$cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);
				$obj1 = new $cls();
				$obj1->hydrate($row);
				TblbloguserPeer::addInstanceToPool($obj1, $key1);
			} 
			$key2 = TbluserPeer::getPrimaryKeyHashFromRow($row, $startcol);
			if ($key2 !== null) {
				$obj2 = TbluserPeer::getInstanceFromPool($key2);
				if (!$obj2) {

					$omClass = TbluserPeer::getOMClass();

					$cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);
					$obj2 = new $cls();
					$obj2->hydrate($row, $startcol);
					TbluserPeer::addInstanceToPool($obj2, $key2);
				} 
								$obj2->addTblbloguser($obj1);

			} 
			$results[] = $obj1;
		}
		$stmt->closeCursor();
		return $results;
	}


	
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
				$criteria = clone $criteria;

								$criteria->setPrimaryTableName(TblbloguserPeer::TABLE_NAME);

		if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->setDistinct();
		}

		if (!$criteria->hasSelectClause()) {
			TblbloguserPeer::addSelectColumns($criteria);
		}
		
		$criteria->clearOrderByColumns(); 		
				$criteria->setDbName(self::DATABASE_NAME);

		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		$criteria->addJoin(array(TblbloguserPeer::US_USER,), array(TbluserPeer::US_ID,), $join_behavior);
		$stmt = BasePeer::doCount($criteria, $con);

		if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$count = (int) $row[0];
		} else {
			$count = 0; 		}
		$stmt->closeCursor();
		return $count;
	}

	
	public static function doSelectJoinAll(Criteria $c, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TblbloguserPeer::addSelectColumns($c);
		$startcol2 = (TblbloguserPeer::NUM_COLUMNS - TblbloguserPeer::NUM_LAZY_LOAD_COLUMNS);

		TbluserPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + (TbluserPeer::NUM_COLUMNS - TbluserPeer::NUM_LAZY_LOAD_COLUMNS);

		$c->addJoin(array(TblbloguserPeer::US_USER,), array(TbluserPeer::US_ID,), $join_behavior);
		$stmt = BasePeer::doSelect($c, $con);
		$results = array();

		while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$key1 = TblbloguserPeer::getPrimaryKeyHashFromRow($row, 0);
			if (null !== ($obj1 = TblbloguserPeer::getInstanceFromPool($key1))) {
															} else {
				$omClass = TblbloguserPeer::getOMClass();

				$cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);
				$obj1 = new $cls();
				$obj1->hydrate($row);
				TblbloguserPeer::addInstanceToPool($obj1, $key1);
			} 
			
			$key2 = TbluserPeer::getPrimaryKeyHashFromRow($row, $startcol2);
			if ($key2 !== null) {
				$obj2 = TbluserPeer::getInstanceFromPool($key2);
				if (!$obj2) {

					$omClass = TbluserPeer::getOMClass();


					$cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);
					$obj2 = new $cls();
					$obj2->hydrate($row, $startcol2);
					TbluserPeer::addInstanceToPool($obj2, $key2);
				} 
								$obj2->addTblbloguser($obj1);
			} 
			$results[] = $obj1;
		}
		$stmt->closeCursor();
		return $results;
	}

	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return TblbloguserPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}


				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->beginTransaction();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollBack();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(TblbloguserPeer::US_BLOG);
			$selectCriteria->add(TblbloguserPeer::US_BLOG, $criteria->remove(TblbloguserPeer::US_BLOG), $comparison);

			$comparison = $criteria->getComparison(TblbloguserPeer::US_USER);
			$selectCriteria->add(TblbloguserPeer::US_USER, $criteria->remove(TblbloguserPeer::US_USER), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		$affectedRows = 0; 		try {
									$con->beginTransaction();
			$affectedRows += BasePeer::doDeleteAll(TblbloguserPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	 public static function doDelete($values, PropelPDO $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}

		if ($values instanceof Criteria) {
												TblbloguserPeer::clearInstancePool();

						$criteria = clone $values;
		} elseif ($values instanceof Tblbloguser) {
						TblbloguserPeer::removeInstanceFromPool($values);
						$criteria = $values->buildPkeyCriteria();
		} else {
			


			$criteria = new Criteria(self::DATABASE_NAME);
												if (count($values) == count($values, COUNT_RECURSIVE)) {
								$values = array($values);
			}

			foreach ($values as $value) {

				$criterion = $criteria->getNewCriterion(TblbloguserPeer::US_BLOG, $value[0]);
				$criterion->addAnd($criteria->getNewCriterion(TblbloguserPeer::US_USER, $value[1]));
				$criteria->addOr($criterion);

								TblbloguserPeer::removeInstanceFromPool($value);
			}
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->beginTransaction();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);

			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public static function doValidate(Tblbloguser $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(TblbloguserPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(TblbloguserPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach ($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(TblbloguserPeer::DATABASE_NAME, TblbloguserPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = TblbloguserPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($us_blog, $us_user, PropelPDO $con = null) {
		$key = serialize(array((string) $us_blog, (string) $us_user));
 		if (null !== ($obj = TblbloguserPeer::getInstanceFromPool($key))) {
 			return $obj;
		}

		if ($con === null) {
			$con = Propel::getConnection(TblbloguserPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
		$criteria = new Criteria(TblbloguserPeer::DATABASE_NAME);
		$criteria->add(TblbloguserPeer::US_BLOG, $us_blog);
		$criteria->add(TblbloguserPeer::US_USER, $us_user);
		$v = TblbloguserPeer::doSelect($criteria, $con);

		return !empty($v) ? $v[0] : null;
	}
} 

Propel::getDatabaseMap(BaseTblbloguserPeer::DATABASE_NAME)->addTableBuilder(BaseTblbloguserPeer::TABLE_NAME, BaseTblbloguserPeer::getMapBuilder());

